<?php

namespace app\modules\Auth\controllers;

use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use Yii;
use Mpdf\Mpdf;
use yii\base\InvalidArgumentException;
use yii\web\BadRequestHttpException;
use yii\filters\AccessControl;
use common\models\User;
use yii\helpers\ArrayHelper;
use PhpParser\Node\Expr\Print_;
use yii\bootstrap5\ActiveForm;
use yii\helpers\Url;
use app\modules\Auth\models\AdvanceCityIntimationSlip;
use yii\web\Session;

class AdvancecityintimationslipController extends \yii\web\Controller
{
   
    public function actions()
    {
        return [
            'error' => [
                'class' => \yii\web\ErrorAction::class,
            ],
            'captcha' => [
                'class' => \yii\captcha\CaptchaAction::class,
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }
    public function actionIndex()
    {
        $dbNumber= Yii::$app->params['DB_Type'];
        $selectDbName= Yii::$app->params['DB_select_name'][$dbNumber] ?? 'dbOne';
       
        $DB = Yii::$app->session->set('NewDBCity',$selectDbName);

        $model = new AdvanceCityIntimationSlip();

        //
        //day name
        for ($i = 1; $i <= 31; $i++) {
            $DobDate[str_pad($i, 2, '0', STR_PAD_LEFT)] = str_pad($i, 2, '0', STR_PAD_LEFT);
        }
        //month name
        for ($m = 1; $m <= 12; ++$m) {
            $DobMonth[str_pad($m, 2, '0', STR_PAD_LEFT)] = date('F', mktime(0, 0, 0, $m, 1));
        }
        $examDate = strtotime(date('Y-m-d', strtotime(yii::$app->params['examStartDate'])) . "-14 year");
        $MinYear = date('Y', ($examDate));
        $examDate = strtotime(date('1933-01-01'));
        $MaxYear = date('Y', ($examDate));

        $DobYear = array();
        for ($year = $MaxYear; $year <= $MinYear; $year++) {
            $DobYear[$year] = $year;
        }

        //
        
        if ($model->load(Yii::$app->request->post())) {
            //return $this->render('advancedslip_preview');    
                    
            $data = Yii::$app->request->post();
            foreach ($data['AdvanceCityIntimationSlip'] as $key => $value) {
                if (!is_array($value)) {
                    $data['AdvanceCityIntimationSlip']["$key"] = Yii::$app->SanatizeInput->getInput($value);
                }
            }            
            $Day = $data['AdvanceCityIntimationSlip']['Day'];
            $Month = $data['AdvanceCityIntimationSlip']['Month'];
            $Year = $data['AdvanceCityIntimationSlip']['Year'];
            $ApplicationNumber = trim(@$data['AdvanceCityIntimationSlip']['ApplicationNumber']);
            //$candiDOB = $Year . '-' . $Month . '-' . $Day;
            $DOB = $Day .'-' . $Month .'-'. $Year;

             $model_data = Yii::$app->{$selectDbName}->createCommand("exec getCommonDataSP :select, :input, :table")
                        ->bindValue(':select', '*')
                        ->bindValue(':input', "WHERE appno='$ApplicationNumber' AND DOB='$DOB'")
                        ->bindValue(':table', 'UGCNetCityIntimationTblLive')
                        ->queryOne();

                        // echo "<pre>";
                        // echo $selectDbName;
                        // print_r($model_data); die;

            if(isset($model_data) && !empty($model_data)){
                Yii::$app->{$selectDbName}->createCommand("exec spCityIntemationLog :ApplicationNumber,:CandidateIP,:CandidateDownload")
                    ->bindValue(':ApplicationNumber', $ApplicationNumber)
                    ->bindValue(':CandidateIP', Yii::$app->request->getUserIP())
                    ->bindValue(':CandidateDownload', 'cityIntimation')
                    ->execute();
                return $this->render('advancedslip_preview',[
                                'result'=>$model_data
                            ]);
            }else{
                Yii::$app->session->setFlash('error', 'Sorry, Record not found.');
                return $this->redirect('index');
            }

            
        }
        return $this->render('index', [
            'model' => $model,
            'DobDate'   => $DobDate,
            'DobMonth'   => $DobMonth,
            'DobYear'   =>  $DobYear
            // 'DobDate'   => Yii::$app->masterdata->dayArray(),
            // 'DobMonth'   => Yii::$app->masterdata->monthArray(),
            // 'DobYear'   =>  Yii::$app->masterdata->yearArray()
        ]);
        
    }
   
  
    // public function actionGetpaymentstatus($ID){
    //    return Yii::$app->{$DB}->createCommand("exec getCommonDataSP :select, :input, :table")
    //         ->bindValue(':select', 'PaymentStatus,Status')
    //         ->bindValue(':input', "WHERE IsActive=1 and ID=$ID")
    //         ->bindValue(':table', 'CandidateTbl')
    //         ->queryAll();
    // }
        
    public function actionPrintDownloadCity()
    {
        $DB = Yii::$app->session->get('NewDBCity');
      
        if ($this->request->isPost) {
            $data= Yii::$app->request->post();
                    if(isset($data['applicationNumber'])){
                        $candiApplicationNo =  trim($data['applicationNumber']);
                       $response= Yii::$app->{$DB}->createCommand("exec spCityIntemationLog :ApplicationNumber,:CandidateIP,:CandidateDownload")
                                ->bindValue(':ApplicationNumber', $candiApplicationNo)
                                ->bindValue(':CandidateIP', Yii::$app->request->getUserIP())
                                ->bindValue(':CandidateDownload', 'City Intemation Print')
                                ->execute();
                               echo $response; die;
            }
        }


    }

}